﻿using System;
using System.IO;
using System.Data;
using System.Data.Common;
using System.Configuration;

namespace Aspitalia.Books.Web.Chapter9
{
    public partial class DbProviderFactory : System.Web.UI.Page
    {
        protected void SelectDbProvider(object sender, EventArgs e)
        {
            string providerInvariantName = "[Nessuna selezione]";
            string connectionString = "[Nessuna selezione]";
            
            DataTable dt = new DataTable();

            if (DbProviderSelect.SelectedIndex > 0)
            {
                // Nome invariante del managed data provider
                providerInvariantName = ConfigurationManager.ConnectionStrings[DbProviderSelect.SelectedValue].ProviderName;

                // Stringa di connessione
                connectionString = ConfigurationManager.ConnectionStrings[DbProviderSelect.SelectedValue].ConnectionString;
                
                // MS Access
                if (DbProviderSelect.SelectedValue.Equals("MdbNorthwind"))
                {
                    connectionString = GetFullPathNameFromDBFileName(connectionString);
                    connectionString = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" + connectionString;
                }

                // Creazione dell'oggetto factory
                System.Data.Common.DbProviderFactory factory = DbProviderFactories.GetFactory(providerInvariantName);

                // Interrogazione del database
                using (DbConnection conn = factory.CreateConnection())
                {
                    conn.ConnectionString = connectionString;
                    conn.Open();

                    // Modalità disconnessa: popolamento di un oggetto DataTable
                    using (DbDataAdapter adatpter = factory.CreateDataAdapter())
                    {
                        DbCommand selectCmd = factory.CreateCommand();
                        selectCmd.CommandText = "SELECT * FROM Customers";
                        selectCmd.Connection = conn;
                        adatpter.SelectCommand = selectCmd;
                        adatpter.Fill(dt);
                    }

                } // La connessione viene chiusa automaticamente alla fine del blocco Using
            }

            ProviderLiteral.Text = providerInvariantName;
            ConnectionStringLiteral.Text = connectionString;
            
            // Data binding della griglia di dati
            ResultGrid.DataSource = dt;
            ResultGrid.DataBind();
        }

        // Ricava il percorso assoluto dal percorso relativo del file MDB
        private string GetFullPathNameFromDBFileName(string relativeFileName)
        {
            relativeFileName = relativeFileName.Replace('/', '\\');
            
            if (relativeFileName.StartsWith("~\\"))
                relativeFileName = relativeFileName.Substring(2);
            else if (relativeFileName.StartsWith("\\"))
                relativeFileName = relativeFileName.Substring(1);
            
            return Path.Combine(HttpRuntime.AppDomainAppPath, relativeFileName);
        }
    }
}
