Imports System
Imports System.Data
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.IO
Imports System.Collections
Imports System.Collections.Generic


Namespace ASPItalia.Books.Web.Chapter11

    '/ <summary>
    '/  Rappresenta un enumeratore del file system per un certo path
    '/ </summary>
    Friend Class FileSystemHierarchicalEnumerable
        Implements IHierarchicalEnumerable

        Private path As DirectoryInfo
        Private parent As FileSystemHierarchyData
        Private viewPath As String
        Private dataSourceView As FileSystemHierarchicalDataSourceView

        Friend Sub New(ByVal path As DirectoryInfo, ByVal parent As FileSystemHierarchyData, ByVal viewPath As String, ByVal dataSourceView As FileSystemHierarchicalDataSourceView)
            Me.path = path
            Me.parent = parent
            Me.viewPath = viewPath
            Me.dataSourceView = dataSourceView
        End Sub

#Region "IHierarchicalEnumerable Members"

        Private Function GetHierarchyData(ByVal EnumeratedItem As Object) As IHierarchyData Implements IHierarchicalEnumerable.GetHierarchyData
            Dim fi As FileSystemInfo = DirectCast(EnumeratedItem, FileSystemInfo)
            Return New FileSystemHierarchyData(parent, fi, String.Format("{0}/{1}", Me.viewPath, fi.Name), Me.dataSourceView)
        End Function

#End Region

#Region "IEnumerable Members"

        Private Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
            ' Restituisco prima le directory
            Dim di As DirectoryInfo
            For Each di In Me.path.GetDirectories()

            Next

            Dim l As New List(Of FileSystemInfo)
            l.AddRange(Me.path.GetDirectories())

            ' Solo se non  stato richiesto solo le directory
            If Me.dataSourceView.ShowHierarchicalFiles Then
                ' Restituisco anche i files
                l.AddRange(Me.path.GetFiles())
            End If

            Return l.GetEnumerator()
        End Function

#End Region
    End Class

End Namespace