Imports System
Imports System.Data
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.IO

Namespace ASPItalia.Books.Web.Chapter11

    Friend Class FileSystemHierarchyData
        Implements IHierarchyData

        Private _pathInfo As FileSystemInfo
        Private _parent As FileSystemHierarchyData
        Private dataSourceView As FileSystemHierarchicalDataSourceView
        Private _viewPath As String

        Public Sub New(ByVal parent As FileSystemHierarchyData, ByVal pathInfo As FileSystemInfo, ByVal viewPath As String, ByVal dataSourceView As FileSystemHierarchicalDataSourceView)
            Me._parent = parent
            Me._viewPath = viewPath
            Me._pathInfo = pathInfo
            Me.dataSourceView = dataSourceView
        End Sub

#Region "IHierarchyData Members"

        Private Function GetChildren() As IHierarchicalEnumerable Implements IHierarchyData.GetChildren
            ' Solo se  una directory restituisco la lista delle directory figlie
            If TypeOf Me._pathInfo Is DirectoryInfo Then
                Return New FileSystemHierarchicalEnumerable(DirectCast(_pathInfo, DirectoryInfo), Me, Me._viewPath, Me.dataSourceView)
            Else
                Return Nothing
            End If
        End Function

        Private Function GetParent() As IHierarchyData Implements IHierarchyData.GetParent
            Return _parent
        End Function

        Private ReadOnly Property HasChildren() As Boolean Implements IHierarchyData.HasChildren
            Get
                Return TypeOf Me._pathInfo Is DirectoryInfo
            End Get
        End Property

        Private ReadOnly Property Item() As Object Implements IHierarchyData.Item
            Get
                Return Me._pathInfo
            End Get
        End Property

        Private ReadOnly Property Path() As String Implements IHierarchyData.Path
            Get
                Return Me._viewPath
            End Get
        End Property


        Private ReadOnly Property Type() As String Implements IHierarchyData.Type
            Get
                Return Me._pathInfo.GetType().Name
            End Get
        End Property

#End Region
    end class
End Namespace