Imports System
Imports System.Collections
Imports System.Data
Imports System.Configuration
Imports System.IO
Imports System.Net
Imports System.Text
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls

Namespace ASPItalia.Books.Web.Chapter11

    Public Class FtpDataSourceView
        Inherits DataSourceView
        Private owner As FtpDataSource

        Public Sub New(ByVal owner As FtpDataSource, ByVal viewName As String)
            MyBase.New(owner, viewName)
            Me.owner = owner
        End Sub

        Protected Overrides Function ExecuteSelect(ByVal arguments As DataSourceSelectArguments) As IEnumerable
            ' Ottengo l'oggetto FtpRequest
            Dim request As FtpWebRequest = owner.GetFtpRequest(Nothing)
            request.Method = WebRequestMethods.Ftp.ListDirectoryDetails

            ' Ottengo la risposta con la lista
            Using response As FtpWebResponse = CType(request.GetResponse(), FtpWebResponse)
                Using stream As Stream = response.GetResponseStream()
                    ' Parserizzo il risultato
                    Return Me.owner.Parser.ParseListDirectoryDetails(stream)
                End Using
            End Using
        End Function

        Protected Overrides Function ExecuteDelete(ByVal keys As IDictionary, ByVal oldValues As IDictionary) As Integer
            If Not keys.Contains("Name") Then
                Throw New HttpException("Cannot found Name key to identify file to delete")
            End If
            If Not keys.Contains("IsDirectory") Then
                Throw New HttpException("Cannot found IsDirectory key to identify if it's a directory or file")
            End If

            ' Ottengo l'oggetto FtpRequest
            Dim request As FtpWebRequest = owner.GetFtpRequest(keys("Name").ToString())
            ' In base al campo IsDirectory uso il metodo appropriato
            If Convert.ToBoolean(keys("IsDirectory")) Then
                request.Method = WebRequestMethods.Ftp.RemoveDirectory
            Else
                request.Method = WebRequestMethods.Ftp.DeleteFile
            End If

            Using response As FtpWebResponse = CType(request.GetResponse(), FtpWebResponse)
                If response.StatusCode = FtpStatusCode.FileActionOK Then
                    Return 1
                Else
                    Return 0
                End If
            End Using
        End Function

        Public Overrides ReadOnly Property CanDelete() As Boolean
            Get
                Return True
            End Get
        End Property

    End Class

End Namespace
