<%@ Page Language="C#" %>

<%@ Register Src="Customers.ascx" TagName="Customers" TagPrefix="uc1" %>
<%@ Register Src="Orders.ascx" TagName="Orders" TagPrefix="uc1" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    protected void editWebPartLink_Click(object sender, EventArgs e)
    {
        this.webPartManager.DisplayMode = WebPartManager.EditDisplayMode;
    }

    protected void catalogLink_Click(object sender, EventArgs e)
    {
        this.webPartManager.DisplayMode = WebPartManager.CatalogDisplayMode;
    }

    protected override void OnInitComplete(EventArgs e)
    {
        base.OnInitComplete(e);

        // Carico tutte le modalit disponibili per questa pagina
        foreach (WebPartDisplayMode mode in webPartManager.SupportedDisplayModes)
        {
            // Solo se  disponibile lo aggiungo alla lista
            if (mode.IsEnabled(webPartManager))
            {
                ListItem item = new ListItem(mode.Name);
                modesList.Items.Add(item);
            }
        }

        // Auto seleziono la prima modalit
        webPartManager.DisplayMode = webPartManager.DisplayModes[modesList.SelectedValue];
    }

    void modesList_SelectedIndexChanged(object s, EventArgs e)
    {
        webPartManager.DisplayMode = webPartManager.DisplayModes[modesList.SelectedValue];
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>13.22</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:WebPartManager ID="webPartManager" runat="server">
        </asp:WebPartManager>
        
        Modalit <asp:DropDownList ID="modesList" runat="server" AutoPostBack="true" OnSelectedIndexChanged="modesList_SelectedIndexChanged" />

        <!-- zone dove posizionare le webpart -->        
        <asp:WebPartZone ID="firstZone" runat="server" HeaderText="Prima zona" BorderColor="#CCCCCC" Font-Names="Verdana" Padding="6">
            <PartChromeStyle BackColor="#F7F6F3" BorderColor="#E2DED6" Font-Names="Verdana" ForeColor="White" />
            <MenuLabelHoverStyle ForeColor="#E2DED6" />
            <EmptyZoneTextStyle Font-Size="0.8em" />
            <MenuLabelStyle ForeColor="White" />
            <MenuVerbHoverStyle BackColor="#F7F6F3" BorderColor="#CCCCCC" BorderStyle="Solid"
                BorderWidth="1px" ForeColor="#333333" />
            <HeaderStyle Font-Size="0.7em" ForeColor="#CCCCCC" HorizontalAlign="Center" />
            <MenuVerbStyle BorderColor="#5D7B9D" BorderStyle="Solid" BorderWidth="1px" ForeColor="White" />
            <PartStyle Font-Size="0.8em" ForeColor="#333333" />
            <TitleBarVerbStyle Font-Size="0.6em" Font-Underline="False" ForeColor="White" />
            <MenuPopupStyle BackColor="#5D7B9D" BorderColor="#CCCCCC" BorderWidth="1px" Font-Names="Verdana"
                Font-Size="0.6em" />
            <PartTitleStyle BackColor="#5D7B9D" Font-Bold="True" Font-Size="0.8em" ForeColor="White" />
        </asp:WebPartZone>
        <asp:WebPartZone ID="secondZone" runat="server" HeaderText="Seconda zona" BorderColor="#CCCCCC" Font-Names="Verdana" Padding="6">
            <PartChromeStyle BackColor="#F7F6F3" BorderColor="#E2DED6" Font-Names="Verdana" ForeColor="White" />
            <MenuLabelHoverStyle ForeColor="#E2DED6" />
            <EmptyZoneTextStyle Font-Size="0.8em" />
            <MenuLabelStyle ForeColor="White" />
            <MenuVerbHoverStyle BackColor="#F7F6F3" BorderColor="#CCCCCC" BorderStyle="Solid"
                BorderWidth="1px" ForeColor="#333333" />
            <HeaderStyle Font-Size="0.7em" ForeColor="#CCCCCC" HorizontalAlign="Center" />
            <MenuVerbStyle BorderColor="#5D7B9D" BorderStyle="Solid" BorderWidth="1px" ForeColor="White" />
            <PartStyle Font-Size="0.8em" ForeColor="#333333" />
            <TitleBarVerbStyle Font-Size="0.6em" Font-Underline="False" ForeColor="White" />
            <MenuPopupStyle BackColor="#5D7B9D" BorderColor="#CCCCCC" BorderWidth="1px" Font-Names="Verdana"
                Font-Size="0.6em" />
            <PartTitleStyle BackColor="#5D7B9D" Font-Bold="True" Font-Size="0.8em" ForeColor="White" />
        </asp:WebPartZone>
        
        <!-- zona dove posizionare il catalogo con la lista di webparts -->
        <asp:CatalogZone ID="catalogZone" runat="server" HeaderText="Principale" BackColor="#F7F6F3" BorderColor="#CCCCCC" BorderWidth="1px" Font-Names="Verdana" Padding="6">
            <ZoneTemplate>
                <asp:DeclarativeCatalogPart ID="declarativeCatalogPart" runat="server">
                    <WebPartsTemplate>
                        <uc1:Customers ID="customers" Title="Clienti" runat="server" />
                        <uc1:Orders ID="orders" Title="Ordini" runat="server" />
                    </WebPartsTemplate>
                </asp:DeclarativeCatalogPart>
                <asp:PageCatalogPart ID="pageCatalogPart" runat="server" />
                <asp:ImportCatalogPart ID="importCatalogPart" runat="server" />
            </ZoneTemplate>
            <HeaderVerbStyle Font-Bold="False" Font-Size="0.8em" Font-Underline="False" ForeColor="#333333" />
            <PartTitleStyle BackColor="#5D7B9D" Font-Bold="True" Font-Size="0.8em" ForeColor="White" />
            <PartChromeStyle BorderColor="#E2DED6" BorderStyle="Solid" BorderWidth="1px" />
            <InstructionTextStyle Font-Size="0.8em" ForeColor="#333333" />
            <PartLinkStyle Font-Size="0.8em" />
            <EmptyZoneTextStyle Font-Size="0.8em" ForeColor="#333333" />
            <LabelStyle Font-Size="0.8em" ForeColor="#333333" />
            <VerbStyle Font-Names="Verdana" Font-Size="0.8em" ForeColor="#333333" />
            <PartStyle BorderColor="#F7F6F3" BorderWidth="5px" />
            <SelectedPartLinkStyle Font-Size="0.8em" />
            <FooterStyle BackColor="#E2DED6" HorizontalAlign="Right" />
            <HeaderStyle BackColor="#E2DED6" Font-Bold="True" Font-Size="0.8em" ForeColor="#333333" />
            <EditUIStyle Font-Names="Verdana" Font-Size="0.8em" ForeColor="#333333" />
        </asp:CatalogZone>

        <!-- zona dove si modificano le propriet della webpart -->
        <asp:EditorZone ID="editorZone" runat="server" BackColor="#F7F6F3" BorderColor="#CCCCCC" BorderWidth="1px" Font-Names="Verdana" Padding="6">
            <ZoneTemplate>
                <asp:PropertyGridEditorPart Title="Propriet&#224;" ID="PropertyGridEditorPart1" runat="server" />
                <asp:AppearanceEditorPart ID="AppearanceEditorPart1" runat="server" />
                <asp:BehaviorEditorPart ID="BehaviorEditorPart1" runat="server" />
                <asp:LayoutEditorPart ID="LayoutEditorPart1" runat="server" />
            </ZoneTemplate>
            <HeaderStyle BackColor="#E2DED6" Font-Bold="True" Font-Size="0.8em" ForeColor="#333333" />
            <LabelStyle Font-Size="0.8em" ForeColor="#333333" />
            <HeaderVerbStyle Font-Bold="False" Font-Size="0.8em" Font-Underline="False" ForeColor="#333333" />
            <PartChromeStyle BorderColor="#E2DED6" BorderStyle="Solid" BorderWidth="1px" />
            <PartStyle BorderColor="#F7F6F3" BorderWidth="5px" />
            <FooterStyle BackColor="#E2DED6" HorizontalAlign="Right" />
            <EditUIStyle Font-Names="Verdana" Font-Size="0.8em" ForeColor="#333333" />
            <InstructionTextStyle Font-Size="0.8em" ForeColor="#333333" />
            <ErrorStyle Font-Size="0.8em" />
            <VerbStyle Font-Names="Verdana" Font-Size="0.8em" ForeColor="#333333" />
            <EmptyZoneTextStyle Font-Size="0.8em" ForeColor="#333333" />
            <PartTitleStyle Font-Bold="True" Font-Size="0.8em" ForeColor="#333333" />
        </asp:EditorZone>
        
        <!-- zona per la configurazione delle connessioni -->
        <asp:ConnectionsZone ID="connectionsZone" runat="server" BackColor="#F7F6F3" BorderColor="#CCCCCC" BorderWidth="1px" Font-Names="Verdana" Padding="6">
            <LabelStyle Font-Size="0.8em" ForeColor="#333333" />
            <FooterStyle BackColor="#E2DED6" HorizontalAlign="Right" />
            <VerbStyle Font-Names="Verdana" Font-Size="0.8em" ForeColor="#333333" />
            <HeaderVerbStyle Font-Bold="False" Font-Size="0.8em" Font-Underline="False" ForeColor="#333333" />
            <HeaderStyle BackColor="#E2DED6" Font-Bold="True" Font-Size="0.8em" ForeColor="#333333" />
            <InstructionTextStyle Font-Size="0.8em" ForeColor="#333333" />
            <EditUIStyle Font-Names="Verdana" Font-Size="0.8em" ForeColor="#333333" />
            
        </asp:ConnectionsZone>
    </form>
</body>
</html>
