<%@ Page Language="VB" AutoEventWireup="true" masterpagefile="~/MasterPage.master" %>
<%@ outputcache duration="5" varybyparam="none" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
<script runat="server">
	protected sub btnAggiungiInsert1_Click(sender As Object, e As EventArgs) 
		Cache.Insert("chiave", "valore")
		lbl1.Text = "elemento aggiunto in cache"
	end sub

	protected sub btnAggiungiInsert2_Click(sender As Object, e As EventArgs) 
		Cache.Insert("chiave", "valore", new CacheDependency(Server.MapPath("data.xml")))
		lbl2.Text = "elemento aggiunto in cache con dipendenza dal file"
	End Sub

	Protected Sub btnAggiungiInsert3_Click(ByVal sender As Object, ByVal e As EventArgs)
		Cache("Dip1") = DateTime.Now
		Cache.Insert("chiave", "valore", New CacheDependency(Nothing, New String() {"Dip1"}))
		lbl3.Text = "elemento aggiunto in cache con dipendenza da chiave"
	End Sub

	Protected Sub btnAggiungiInsert4_Click(ByVal sender As Object, ByVal e As EventArgs)
		Cache.Insert("chiave", "valore", nothing, DateTime.Now.AddSeconds(10), Cache.NoSlidingExpiration)
		lbl4.Text = "elemento aggiunto in cache con scadenza il " + DateTime.Now.AddSeconds(10)
	End Sub

	Protected Sub btnAggiungiInsert5_Click(ByVal sender As Object, ByVal e As EventArgs)
		Cache.Insert("chiave", "valore", nothing, Cache.NoAbsoluteExpiration, New TimeSpan(0, 0, 10))
		lbl5.Text = "elemento aggiunto in cache con scadenza il a 10 secondi da ogni accesso"
	End Sub

	Protected Sub btnAggiungiInsert6_Click(ByVal sender As Object, ByVal e As EventArgs)
		Cache.Insert("chiave", "valore", Nothing, DateTime.Now.AddSeconds(10), Cache.NoSlidingExpiration, CacheItemPriority.Default, New CacheItemRemovedCallback(AddressOf onRemove))
		lbl6.Text = "elemento aggiunto in cache con callback"
	End Sub

	Protected Sub btnModificaChiaveDip_Click(ByVal sender As Object, ByVal e As EventArgs)
		Cache("dip1") = DateTime.Now
		lbl3.Text = "Chiave di dipendenza modificata"
	End Sub

	Protected Sub btnModificaFileDip_Click(ByVal sender As Object, ByVal e As EventArgs)
		Dim fs As New System.IO.FileStream(Server.MapPath("data.xml"), System.IO.FileMode.Append)
		fs.WriteByte(0)
		fs.Close()
		lbl2.Text = "File di dipendenza modificato"
	End Sub

	Protected Sub btnVisualizza_Click(ByVal sender As Object, ByVal e As EventArgs)
		If (Cache("chiave") Is Nothing) Then
			lblVis.Text = "Oggetto scaduto"
		Else
			lblVis.Text = Cache("chiave").ToString()
		End If
	End Sub

	Private Sub onRemove(ByVal key As String, ByVal value As Object, ByVal reason As CacheItemRemovedReason)
		Dim s As String = "Elemento rimosso dalla cache perch: "
		If reason = CacheItemRemovedReason.DependencyChanged Then
			s += "Modificata dipendenza"
		ElseIf reason = CacheItemRemovedReason.Expired Then
			s += "Scaduto il tempo"
		ElseIf reason = CacheItemRemovedReason.Removed Then
			s += "Rimosso da codice"
		Else
			s += "Rimosso dal Garbage Collector per liberare memoria"
			Log(s)
		End If
	End Sub

	Private Sub Log(ByVal value As String)
	End Sub
</script>
	<h4>Visualizzazione contenuto cache</h4>
	<asp:button id="btnVisualizza" runat="server" text="Visualizza" onclick="btnVisualizza_Click" />
	<asp:label id="lblVis" runat="server" />
	<hr />

	<h4>Esempio 17.12 - Aggiunta tramite metodo insert con chiave e valore</h4>
	<asp:button id="btnAggiungiInsert1" runat="server" text="Aggiungi" onclick="btnAggiungiInsert1_Click" />
	<asp:label id="lbl1" runat="server" />
	<hr />

	<h4>Esempio 17.13 - Aggiunta tramite metodo insert con chiave, valore e dipendenza da file</h4>
	<asp:button id="btnAggiungiInsert2" runat="server" text="Aggiungi" onclick="btnAggiungiInsert2_Click" />
	<asp:button id="btnModificaFileDip" runat="server" text="Modifica Dipendenza" onclick="btnModificaFileDip_Click" />
	<asp:label id="lbl2" runat="server" />
	<hr />

	<h4>Esempio 17.13 - Aggiunta tramite metodo insert con chiave, valore e dipendenza da altra chiave in cache</h4>
	<asp:button id="btnAggiungiInsert3" runat="server" text="Aggiungi" onclick="btnAggiungiInsert3_Click" />
	<asp:button id="btnModificaChiaveDip" runat="server" text="Modifica Dipendenza" onclick="btnModificaChiaveDip_Click" />
	<asp:label id="lbl3" runat="server" />
	<hr />

	<h4>Esempio 17.14 - Aggiunta tramite metodo insert con scadenza fissa tra 10 secondi</h4>
	<asp:button id="btnAggiungiInsert4" runat="server" text="Aggiungi" onclick="btnAggiungiInsert4_Click" />
	<asp:label id="lbl4" runat="server" />
	<hr />

	<h4>Esempio 17.14 - Aggiunta tramite metodo insert con scadenza a 10 secondi dal'ultimo accesso</h4>
	<asp:button id="btnAggiungiInsert5" runat="server" text="Aggiungi" onclick="btnAggiungiInsert5_Click" />
	<asp:label id="lbl5" runat="server" />
	<hr />

	<h4>Esempio 17.15 - Aggiunta tramite metodo insert con callback alla scadenza</h4>
	<asp:button id="btnAggiungiInsert6" runat="server" text="Aggiungi" onclick="btnAggiungiInsert6_Click" />
	<asp:label id="lbl6" runat="server" />
</asp:Content>